################################################################################
#   Copyright 2011 Chris Statzer and David Reichard                            #
#                                                                              #
#   Licensed under the Apache License, Version 2.0 (the "License");            #
#   you may not use this file except in compliance with the License            #
#   You may obtain a copy of the License at                                    #
#                                                                              #
#       http://www.apache.org/licenses/LICENSE-2.0                             #
#                                                                              #
#   Unless required by applicable law or agreed to in writing, software        #
#   distributed under the License is distributed on an "AS IS" BASIS,          #
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
#   See the License for the specific language governing permissions and        #
#   limitations under the License.                                             #
################################################################################

###############################################################################
################################################################ Camera ####### 
###############################################################################

class Camera (object):
    """
        Simple camera class to offset the map when the player moves
        gets updated in the loop and uses its ref to the player
        to calc its numbers. This is prob bad design, screw it
        I got it working in like 30 minutes.
    """
    def __init__(self, player, window, game_map):
        self.offset_x, self.offset_y = 0, 0
        self.player = player
        self.window = window
        self.game_map = game_map
        self.calc_offset()
        
    def calc_offset(self, dt=1):
        ## Check to see if the camera is at a border if so then set
        ## the offset to a fixed position. gives the illusion you are
        ## approaching the "edge" of the map.
        if self.player.x <= self.window.width / 2:
            self.offset_x = 0
        elif self.player.x >= self.game_map.width - (self.window.width / 2):
            self.offset_x = (self.game_map.width - (self.window.width)) * -1.0
        else:
            self.offset_x = (self.player.x - (self.window.width / 2)) * -1.0
        

        if self.player.y <= self.window.height / 2:
            self.offset_y = 0
        elif self.player.y >= self.game_map.height - (self.window.height / 2):
            self.offset_y = (self.game_map.height - (self.window.height)) * -1.0
        else:
            self.offset_y = (self.player.y - (self.window.height / 2)) * -1.0

    def get_offset(self):
        return (self.offset_x, self.offset_y)
